\input{./data/toy_task}

\chapter{Data}
\label{cap:data}

This chapter describes the data used and how it's being fed to the various NN models.

\section{Cell nucleus dataset}
\label{subsec:toy_task-data-intro}

The dataset contains microscopy images of dividing cells together foreground/background masks. \fg[toy_data_sample] shows a sample (using the color map \texttt{\cmap}).

\begin{figure*}[htp]
    \centering
    \showSample{10}
\caption{Data sample from cell nucleus dataset}
\label{fig:toy_data_sample}
\end{figure*}

\subsubsection{Parsing}
\label{subsec:toy_task-data-parsing}

Each image (and corresponding mask) is passed through a pipeline before being fed to the NN. The steps are

\begin{enumerate}
    \item open \texttt{.tiff} file
    \item threshold outliers (based on $[2, 98]$ percentiles)
    \item min-max normalization (in range $[0, 1]$ since image is grayscale)
    \item center crop of size \inpsize $\times$ \inpsize
\end{enumerate}

\subsubsection{Border detection}
\label{subsec:toy_task-data-borders}

Classic \href{https://scikit-image.org/docs/dev/api/skimage.segmentation.html#skimage.segmentation.find_boundaries}{derivative filters} is applied to each ground truth mask to detect the borders of the cells, thus providing a 3rd label \ie{} \texttt{border}. Note that now the image has \nimageclasses{} classes (and channels):
\begin{enumerate}
    \item background
    \item foreground (\ie{} the positive mask minus the borders)
    \item borders (usually just two hundreds pixels, $\textless 1 \%$)
\end{enumerate}

\section{EM flybrain dataset}
\label{subsec:toy_task-data-em}

Data is taken from the \href{https://cremi.org/data/}{MICCAI Challenge}. Each image (and corresponding mask) is passed through the same pipeline (see \ref{subsec:toy_task-data-parsing}) before being fed to the NN, except that at the end the crop is a random $32 \times 32$ pixels.

\section{Augmentation}
\label{subsec:toy_task-data-augmentation}

Basic data augmentation has been done (when appropriate). Each image is replaced with a transformed version of itself. Following these transformations were \textit{randomly} applied:

\begin{enumerate}
    \item \texttt{flip}: vertical flipping
    \item \texttt{flop}: horizontal flipping
    \item blur via Gaussian filter
    \item Gaussian/Poisson noise
\end{enumerate}
